diff --git a/build/valgrind/mach_commands.py b/build/valgrind/mach_commands.py
index 8109f0784a..d3e28e1daa 100644
--- a/build/valgrind/mach_commands.py
+++ b/build/valgrind/mach_commands.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import logging
 import os
diff --git a/build/valgrind/output_handler.py b/build/valgrind/output_handler.py
index df24ff28be..30be3a180d 100644
--- a/build/valgrind/output_handler.py
+++ b/build/valgrind/output_handler.py
@@ -2,12 +2,11 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function, unicode_literals
 
 import logging
 import re
 
-class OutputHandler(object):
+class OutputHandler:
     '''
     A class for handling Valgrind output.
 
diff --git a/build/variables.py b/build/variables.py
index de0903af28..dc6205d7cc 100644
--- a/build/variables.py
+++ b/build/variables.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function, unicode_literals
 
 import os
 import subprocess
@@ -90,7 +89,7 @@ def source_repo_header(output):
         output.write('#define MOZ_SOURCE_STAMP %s\n' % changeset)
 
     if repo and buildconfig.substs.get('MOZ_INCLUDE_SOURCE_INFO'):
-        source = '%s/rev/%s' % (repo, changeset)
+        source = '{}/rev/{}'.format(repo, changeset)
         output.write('#define MOZ_SOURCE_REPO %s\n' % repo)
         output.write('#define MOZ_SOURCE_URL %s\n' % source)
 
diff --git a/build/win32/autobinscope.py b/build/win32/autobinscope.py
index fdba68e0c3..bdc5d27f69 100644
--- a/build/win32/autobinscope.py
+++ b/build/win32/autobinscope.py
@@ -23,7 +23,7 @@ BINSCOPE_OUTPUT_LOGFILE = r".\binscope_xml_output.log"
 
 # usage
 if len(sys.argv) < 3:
-  print """usage : autobinscope.by path_to_binary path_to_symbols [log_file_path]"
+  print("""usage : autobinscope.by path_to_binary path_to_symbols [log_file_path]")
 		log_file_path is optional, log will be written to .\binscope_xml_output.log by default"""
   sys.exit(0)
 
@@ -40,7 +40,7 @@ else:
 try:
   binscope_path = os.environ['BINSCOPE']
 except KeyError:
-  print "BINSCOPE environment variable is not set, can't check DEP/ASLR etc. status."
+  print("BINSCOPE environment variable is not set, can't check DEP/ASLR etc. status.")
   sys.exit(0)
   
 try:    
@@ -53,11 +53,11 @@ try:
 
 except WindowsError, (errno, strerror): 
   if errno != 2 and errno != 3:
-    print "Unexpected error ! \nError " + str(errno) + " : " + strerror + "\nExiting !\n"
+    print("Unexpected error ! \nError " + str(errno) + " : " + strerror + "\nExiting !\n")
     sys.exit(0)
   else:
-    print "Could not locate binscope at location : %s\n" % binscope_path
-    print "Binscope wasn't installed or the BINSCOPE env variable wasn't set correctly, skipping this check and exiting..."
+    print("Could not locate binscope at location : %s\n" % binscope_path)
+    print("Binscope wasn't installed or the BINSCOPE env variable wasn't set correctly, skipping this check and exiting...")
     sys.exit(0)
 
 proc.wait()
@@ -66,10 +66,10 @@ output = proc.communicate()[0]
 
 # is this a PASS or a FAIL ? 
 if proc.returncode != 0:
-  print "Error count: %d" % proc.returncode
-  print "TEST-UNEXPECTED-FAIL | autobinscope.py | %s is missing a needed Windows protection, such as /GS or ASLR" % binary_path
+  print("Error count: %d" % proc.returncode)
+  print("TEST-UNEXPECTED-FAIL | autobinscope.py | %s is missing a needed Windows protection, such as /GS or ASLR" % binary_path)
   logfile = open(log_file_path, "r")
   for line in logfile:
     print(line),
 else:
-  print "TEST-PASS | autobinscope.py | %s succeeded" % binary_path
+  print("TEST-PASS | autobinscope.py | %s succeeded" % binary_path)
diff --git a/build/win32/pgomerge.py b/build/win32/pgomerge.py
index 313d66870d..8d0351d960 100755
--- a/build/win32/pgomerge.py
+++ b/build/win32/pgomerge.py
@@ -39,6 +39,6 @@ def MergePGOFiles(basename, pgddir, pgcdir):
 
 if __name__ == '__main__':
   if len(sys.argv) != 3:
-      print >>sys.stderr, "Usage: pgomerge.py <binary basename> <dist/bin>"
+      print("Usage: pgomerge.py <binary basename> <dist/bin>", file=sys.stderr)
       sys.exit(1)
   MergePGOFiles(sys.argv[1], os.getcwd(), sys.argv[2])
diff --git a/build/win32/procmem.py b/build/win32/procmem.py
index 8376d07ea4..61621783f4 100644
--- a/build/win32/procmem.py
+++ b/build/win32/procmem.py
@@ -40,9 +40,9 @@ if __name__ == '__main__':
                                                     0, # no inherit
                                                     int(pid))
         if handle:
-            print "Process %s:" % pid
+            print("Process %s:" % pid)
             vsize, peak_vsize = get_vmsize(handle)
-            print "peak vsize: %d" % peak_vsize
+            print("peak vsize: %d" % peak_vsize)
             ctypes.windll.kernel32.CloseHandle(handle)
         else:
-            print "Couldn't open process %s" % pid
+            print("Couldn't open process %s" % pid)
diff --git a/build/windows_toolchain.py b/build/windows_toolchain.py
index 22e656eff3..5a8552c1e6 100644
--- a/build/windows_toolchain.py
+++ b/build/windows_toolchain.py
@@ -10,7 +10,6 @@
 # When updating behavior of this script, remember to update the docs
 # in ``build/docs/toolchains.rst``.
 
-from __future__ import absolute_import, unicode_literals
 
 import hashlib
 import os
@@ -200,7 +199,7 @@ def format_manifest(manifest):
 
 def write_zip(zip_path, prefix=None):
     """Write toolchain data to a zip file."""
-    if isinstance(prefix, unicode):
+    if isinstance(prefix, str):
         prefix = prefix.encode('utf-8')
 
     with JarWriter(file=zip_path, optimize=False, compress=5) as zip:
diff --git a/client.py b/client.py
index d832c4287d..fe10a0d61a 100755
--- a/client.py
+++ b/client.py
@@ -4,6 +4,7 @@
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
 
+from __future__ import print_function
 LIBFFI_DIRS = (('js/ctypes/libffi', 'libffi'),)
 HG_EXCLUSIONS = ['.hg', '.hgignore', '.hgtags']
 
@@ -22,7 +23,7 @@ if topsrcdir == '':
     topsrcdir = '.'
 
 def check_call_noisy(cmd, *args, **kwargs):
-    print "Executing command:", cmd
+    print("Executing command:", cmd)
     check_call(cmd, *args, **kwargs)
 
 def do_hg_pull(dir, repository, hg):
@@ -67,22 +68,22 @@ def do_cvs_export(modules, tag, cvsroot, cvs):
         cvs_module = module_tuple[1]
         fullpath = os.path.join(topsrcdir, module)
         if os.path.exists(fullpath):
-            print "Removing '%s'" % fullpath
+            print("Removing '%s'" % fullpath)
             shutil.rmtree(fullpath)
 
         (parent, leaf) = os.path.split(module)
-        print "CVS export begin: " + datetime.datetime.utcnow().strftime("%Y-%m-%d %H:%M:%S UTC")
+        print("CVS export begin: " + datetime.datetime.utcnow().strftime("%Y-%m-%d %H:%M:%S UTC"))
         check_call_noisy([cvs, '-d', cvsroot,
                           'export', '-r', tag, '-d', leaf, cvs_module],
                          cwd=os.path.join(topsrcdir, parent))
-        print "CVS export end: " + datetime.datetime.utcnow().strftime("%Y-%m-%d %H:%M:%S UTC")
+        print("CVS export end: " + datetime.datetime.utcnow().strftime("%Y-%m-%d %H:%M:%S UTC"))
 
 def toggle_trailing_blank_line(depname):
   """If the trailing line is empty, then we'll delete it.
   Otherwise we'll add a blank line."""
   lines = open(depname, "r").readlines()
   if not lines:
-      print >>sys.stderr, "unexpected short file"
+      print("unexpected short file", file=sys.stderr)
       return
 
   if not lines[-1].strip():
@@ -95,7 +96,7 @@ def toggle_trailing_blank_line(depname):
 def get_trailing_blank_line_state(depname):
   lines = open(depname, "r").readlines()
   if not lines:
-      print >>sys.stderr, "unexpected short file"
+      print("unexpected short file", file=sys.stderr)
       return "no blank line"
 
   if not lines[-1].strip():
@@ -104,18 +105,18 @@ def get_trailing_blank_line_state(depname):
       return "no blank line"
 
 def update_nspr_or_nss(tag, depfile, destination, hgpath):
-  print "reverting to HG version of %s to get its blank line state" % depfile
+  print("reverting to HG version of %s to get its blank line state" % depfile)
   check_call_noisy([options.hg, 'revert', depfile])
   old_state = get_trailing_blank_line_state(depfile)
-  print "old state of %s is: %s" % (depfile, old_state)
+  print("old state of %s is: %s" % (depfile, old_state))
   do_hg_replace(destination, hgpath, tag, HG_EXCLUSIONS, options.hg)
   new_state = get_trailing_blank_line_state(depfile)
-  print "new state of %s is: %s" % (depfile, new_state)
+  print("new state of %s is: %s" % (depfile, new_state))
   if old_state == new_state:
-    print "toggling blank line in: ", depfile
+    print("toggling blank line in: ", depfile)
     toggle_trailing_blank_line(depfile)
   tag_file = destination + "/TAG-INFO"
-  print >>file(tag_file, "w"), tag
+  print(tag, file=open(tag_file, "w"))
 
 o = OptionParser(usage="client.py [options] update_nspr tagname | update_nss tagname | update_libffi tagname")
 o.add_option("--skip-mozilla", dest="skip_mozilla",
@@ -139,7 +140,7 @@ except IndexError:
     sys.exit(2)
 
 if action in ('checkout', 'co'):
-    print >>sys.stderr, "Warning: client.py checkout is obsolete."
+    print("Warning: client.py checkout is obsolete.", file=sys.stderr)
     pass
 elif action in ('update_nspr'):
     tag, = args[1:]
diff --git a/config/MozZipFile.py b/config/MozZipFile.py
index 337fe0521b..dc7add4c3a 100644
--- a/config/MozZipFile.py
+++ b/config/MozZipFile.py
@@ -18,7 +18,7 @@ class ZipFile(zipfile.ZipFile):
   def __init__(self, file, mode="r", compression=zipfile.ZIP_STORED,
                lock = False):
     if lock:
-      assert isinstance(file, basestring)
+      assert isinstance(file, str)
       self.lockfile = lock_file(file + '.lck')
     else:
       self.lockfile = None
@@ -46,7 +46,7 @@ class ZipFile(zipfile.ZipFile):
                               date_time=time.localtime(time.time()))
       zinfo.compress_type = self.compression
       # Add some standard UNIX file access permissions (-rw-r--r--).
-      zinfo.external_attr = (0x81a4 & 0xFFFF) << 16L
+      zinfo.external_attr = (0x81a4 & 0xFFFF) << 16
     else:
       zinfo = zinfo_or_arcname
 
@@ -58,7 +58,7 @@ class ZipFile(zipfile.ZipFile):
     # as the old, reuse the existing entry.
 
     doSeek = False # store if we need to seek to the eof after overwriting
-    if self.NameToInfo.has_key(zinfo.filename):
+    if zinfo.filename in self.NameToInfo:
       # Find the last ZipInfo with our name.
       # Last, because that's catching multiple overwrites
       i = len(self.filelist)
@@ -109,14 +109,14 @@ class ZipFile(zipfile.ZipFile):
       # adjust file mode if we originally just wrote, now we rewrite
       self.fp.close()
       self.fp = open(self.filename, 'r+b')
-    all = map(lambda zi: (zi, True), self.filelist) + \
-        map(lambda zi: (zi, False), self._remove)
+    all = [(zi, True) for zi in self.filelist] + \
+        [(zi, False) for zi in self._remove]
     all.sort(lambda l, r: cmp(l[0].header_offset, r[0].header_offset))
     # empty _remove for multiple closes
     self._remove = []
 
     lengths = [all[i+1][0].header_offset - all[i][0].header_offset
-               for i in xrange(len(all)-1)]
+               for i in range(len(all)-1)]
     lengths.append(self.end - all[-1][0].header_offset)
     to_pos = 0
     for (zi, keep), length in zip(all, lengths):
diff --git a/config/check_source_count.py b/config/check_source_count.py
index e347e7a55e..7f993f0390 100755
--- a/config/check_source_count.py
+++ b/config/check_source_count.py
@@ -24,7 +24,7 @@ details = {}
 
 count = 0
 for f in files:
-    text = file(f).read()
+    text = open(f).read()
     match = re.findall(search_string, text)
     if match:
         num = len(match)
diff --git a/config/createprecomplete.py b/config/createprecomplete.py
index 3241d526b2..d70f282ace 100644
--- a/config/createprecomplete.py
+++ b/config/createprecomplete.py
@@ -56,10 +56,10 @@ def generate_precomplete(root_path):
     precomplete_file = open(precomplete_file_path, "wb")
     rel_file_path_list, rel_dir_path_list = get_build_entries(root_path)
     for rel_file_path in rel_file_path_list:
-        precomplete_file.writelines("remove \""+rel_file_path+"\"\n")
+        precomplete_file.write(("remove \""+rel_file_path+"\"\n").encode('utf-8'))
 
     for rel_dir_path in rel_dir_path_list:
-        precomplete_file.writelines("rmdir \""+rel_dir_path+"\"\n")
+        precomplete_file.write(("rmdir \""+rel_dir_path+"\"\n").encode('utf-8'))
 
     precomplete_file.close()
 
diff --git a/config/expandlibs.py b/config/expandlibs.py
index ac06c432f2..668db68bef 100644
--- a/config/expandlibs.py
+++ b/config/expandlibs.py
@@ -27,6 +27,7 @@ ${LIB_PREFIX}${ROOT}.${LIB_SUFFIX} following these rules:
   rules.
 '''
 from __future__ import with_statement
+from __future__ import print_function
 import sys, os, errno
 import expandlibs_config as conf
 
@@ -36,7 +37,7 @@ def ensureParentDir(file):
     if dir and not os.path.exists(dir):
         try:
             os.makedirs(dir)
-        except OSError, error:
+        except OSError as error:
             if error.errno != errno.EEXIST:
                 raise
 
@@ -140,4 +141,4 @@ class ExpandArgs(list):
         return [relativize(arg)]
 
 if __name__ == '__main__':
-    print " ".join(ExpandArgs(sys.argv[1:]))
+    print(" ".join(ExpandArgs(sys.argv[1:])))
diff --git a/config/expandlibs_exec.py b/config/expandlibs_exec.py
index fe9a7f6ebb..adc46a2911 100644
--- a/config/expandlibs_exec.py
+++ b/config/expandlibs_exec.py
@@ -21,6 +21,7 @@ relevant linker options to change the order in which the linker puts the
 symbols appear in the resulting binary. Only works for ELF targets.
 '''
 from __future__ import with_statement
+from __future__ import print_function
 import sys
 import os
 from expandlibs import (
@@ -305,11 +306,11 @@ class SectionFinder(object):
         return syms
 
 def print_command(out, args):
-    print >>out, "Executing: " + " ".join(args)
+    print("Executing: " + " ".join(args), file=out)
     for tmp in [f for f in args.tmp if os.path.isfile(f)]:
-        print >>out, tmp + ":"
+        print(tmp + ":", file=out)
         with open(tmp) as file:
-            print >>out, "".join(["    " + l for l in file.readlines()])
+            print("".join(["    " + l for l in file.readlines()]), file=out)
     out.flush()
 
 def main(args, proc_callback=None):
@@ -339,13 +340,13 @@ def main(args, proc_callback=None):
             proc = subprocess.Popen(args, stdout = subprocess.PIPE, stderr = subprocess.STDOUT)
             if proc_callback:
                 proc_callback(proc)
-        except Exception, e:
-            print >>sys.stderr, 'error: Launching', args, ':', e
+        except Exception as e:
+            print('error: Launching', args, ':', e, file=sys.stderr)
             raise e
         (stdout, stderr) = proc.communicate()
         if proc.returncode and not options.verbose:
             print_command(sys.stderr, args)
-        sys.stderr.write(stdout)
+        sys.stderr.write(stdout.decode('utf-8', 'replace'))
         sys.stderr.flush()
         if proc.returncode:
             return proc.returncode
diff --git a/config/expandlibs_gen.py b/config/expandlibs_gen.py
index b1de63cd02..003e18f910 100644
--- a/config/expandlibs_gen.py
+++ b/config/expandlibs_gen.py
@@ -6,6 +6,7 @@
 descriptor to standard output'''
 
 from __future__ import with_statement
+from __future__ import print_function
 import sys
 import os
 import expandlibs_config as conf
@@ -38,4 +39,4 @@ if __name__ == '__main__':
 
     ensureParentDir(options.output)
     with open(options.output, 'w') as outfile:
-        print >>outfile, generate(args)
+        print(generate(args), file=outfile)
diff --git a/config/find_OOM_errors.py b/config/find_OOM_errors.py
index 16065119b7..830693885e 100644
--- a/config/find_OOM_errors.py
+++ b/config/find_OOM_errors.py
@@ -105,7 +105,7 @@ def count_lines():
 
   lines.sort()
 
-  countlog = file("../OOM_count_log", "w")
+  countlog = open("../OOM_count_log", "w")
   countlog.write("\n".join(lines))
   countlog.flush()
   countlog.close()
@@ -215,7 +215,7 @@ else:
 
 if OPTIONS.regression == None:
   # Don't use a logfile, this is automated for tinderbox.
-  log = file("../OOM_log", "w")
+  log = open("../OOM_log", "w")
 
 
 num_failures = 0
@@ -267,7 +267,7 @@ for f in files:
       # Get valgrind output for a good stack trace
       vcommand = "valgrind --dsymutil=yes -q --log-file=OOM_valgrind_log_file " + command
       run(vcommand)
-      vout = file("OOM_valgrind_log_file").read()
+      vout = open("OOM_valgrind_log_file").read()
       vout = clean_voutput(vout)
       sans_alloc_sites = remove_failed_allocation_backtraces(vout)
 
diff --git a/config/link.py b/config/link.py
index be63216a02..aa47503f0d 100644
--- a/config/link.py
+++ b/config/link.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import expandlibs_exec
 import sys
 import threading
@@ -18,7 +19,7 @@ def periodically_print_status(proc):
         time.sleep(0.5)
         idleTime += 0.5
         if idleTime > 20 * 60:
-          print "Still linking, 20 minutes passed..."
+          print("Still linking, 20 minutes passed...")
           sys.stdout.flush()
           idleTime = 0
 
@@ -42,6 +43,6 @@ def wrap_linker(args):
 
 if __name__ == "__main__":
     if len(sys.argv) < 2:
-        print >>sys.stderr, "Usage: link.py <commandline>"
+        print("Usage: link.py <commandline>", file=sys.stderr)
         sys.exit(1)
     sys.exit(wrap_linker(sys.argv[1:]))
diff --git a/config/mozunit.py b/config/mozunit.py
index 3dddf84ee4..69a3220050 100644
--- a/config/mozunit.py
+++ b/config/mozunit.py
@@ -140,7 +140,7 @@ class MockedOpen(object):
     '''
     def __init__(self, files = {}):
         self.files = {}
-        for name, content in files.iteritems():
+        for name, content in files.items():
             self.files[normcase(os.path.abspath(name))] = content
 
     def __call__(self, name, mode = 'r'):
@@ -158,19 +158,19 @@ class MockedOpen(object):
         return file
 
     def __enter__(self):
-        import __builtin__
-        self.open = __builtin__.open
+        import builtins
+        self.open = builtins.open
         self._orig_path_exists = os.path.exists
         self._orig_path_isdir = os.path.isdir
         self._orig_path_isfile = os.path.isfile
-        __builtin__.open = self
+        builtins.open = self
         os.path.exists = self._wrapped_exists
         os.path.isdir = self._wrapped_isdir
         os.path.isfile = self._wrapped_isfile
 
     def __exit__(self, type, value, traceback):
-        import __builtin__
-        __builtin__.open = self.open
+        import builtins
+        builtins.open = self.open
         os.path.exists = self._orig_path_exists
         os.path.isdir = self._orig_path_isdir
         os.path.isfile = self._orig_path_isfile
diff --git a/config/nsinstall.py b/config/nsinstall.py
index 4814133703..73dac0021d 100755
--- a/config/nsinstall.py
+++ b/config/nsinstall.py
@@ -149,7 +149,7 @@ def _nsinstall_internal(argv):
 
 # nsinstall as a native command is always UTF-8
 def nsinstall(argv):
-  return _nsinstall_internal([unicode(arg, "utf-8") for arg in argv])
+  return _nsinstall_internal([str(arg, "utf-8") for arg in argv])
 
 if __name__ == '__main__':
   # sys.argv corrupts characters outside the system code page on Windows
@@ -174,9 +174,6 @@ if __name__ == '__main__':
     argv = argv_arr[1:argc.value]
   else:
     # For consistency, do it on Unix as well
-    if sys.stdin.encoding is not None:
-      argv = [unicode(arg, sys.stdin.encoding) for arg in sys.argv]
-    else:
-      argv = [unicode(arg) for arg in sys.argv]
+    argv = [str(arg) for arg in sys.argv]
 
   sys.exit(_nsinstall_internal(argv[1:]))
diff --git a/config/printconfigsetting.py b/config/printconfigsetting.py
index ef900a6c05..e6c764019d 100644
--- a/config/printconfigsetting.py
+++ b/config/printconfigsetting.py
@@ -2,30 +2,31 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import configobj
 import sys
 import re
-from StringIO import StringIO
+from io import StringIO
 
 try:
     (file, section, key) = sys.argv[1:]
 except ValueError:
-    print "Usage: printconfigsetting.py <file> <section> <setting>"
+    print("Usage: printconfigsetting.py <file> <section> <setting>")
     sys.exit(1)
 
 with open(file) as fh:
-    content = re.sub('^\s*;', '#', fh.read(), flags=re.M)
+    content = re.sub(r'^\s*;', '#', fh.read(), flags=re.M)
 
 c = configobj.ConfigObj(StringIO(content))
 
 try:
     s = c[section]
 except KeyError:
-    print >>sys.stderr, "Section [%s] not found." % section
+    print("Section [%s] not found." % section, file=sys.stderr)
     sys.exit(1)
 
 try:
-    print s[key]
+    print(s[key])
 except KeyError:
-    print >>sys.stderr, "Key %s not found." % key
+    print("Key %s not found." % key, file=sys.stderr)
     sys.exit(1)
diff --git a/config/pythonpath.py b/config/pythonpath.py
index 0318066148..12fe6b1c73 100644
--- a/config/pythonpath.py
+++ b/config/pythonpath.py
@@ -7,9 +7,10 @@ Run a python script, adding extra directories to the python path.
 """
 
 
+from __future__ import print_function
 def main(args):
     def usage():
-        print >>sys.stderr, "pythonpath.py -I directory script.py [args...]"
+        print("pythonpath.py -I directory script.py [args...]", file=sys.stderr)
         sys.exit(150)
 
     paths = []
@@ -45,7 +46,7 @@ def main(args):
     frozenglobals['__name__'] = '__main__'
     frozenglobals['__file__'] = script
 
-    execfile(script, frozenglobals)
+    exec(compile(open(script, "rb").read(), script, 'exec'), frozenglobals)
 
 # Freeze scope here ... why this makes things work I have no idea ...
 frozenglobals = globals()
diff --git a/config/rebuild_check.py b/config/rebuild_check.py
index a6c3dc87ac..d7540c9359 100644
--- a/config/rebuild_check.py
+++ b/config/rebuild_check.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 import errno
 
@@ -18,7 +19,7 @@ def rebuild_check(args):
     deps = args[1:]
     t = mtime(target)
     if t < 0:
-        print target
+        print(target)
         return
 
     newer = []
@@ -31,13 +32,13 @@ def rebuild_check(args):
             newer.append(dep)
 
     if newer and removed:
-        print 'Rebuilding %s because %s changed and %s was removed' % (target, ', '.join(newer), ', '.join(removed))
+        print('Rebuilding %s because %s changed and %s was removed' % (target, ', '.join(newer), ', '.join(removed)))
     elif newer:
-        print 'Rebuilding %s because %s changed' % (target, ', '.join(newer))
+        print('Rebuilding %s because %s changed' % (target, ', '.join(newer)))
     elif removed:
-        print 'Rebuilding %s because %s was removed' % (target, ', '.join(removed))
+        print('Rebuilding %s because %s was removed' % (target, ', '.join(removed)))
     else:
-        print 'Rebuilding %s for an unknown reason' % target
+        print('Rebuilding %s for an unknown reason' % target)
 
 if __name__ == '__main__':
     import sys
diff --git a/config/tests/unit-expandlibs.py b/config/tests/unit-expandlibs.py
index 3c7e5a44dd..e1b8775961 100644
--- a/config/tests/unit-expandlibs.py
+++ b/config/tests/unit-expandlibs.py
@@ -8,6 +8,7 @@ from shutil import rmtree
 import mozunit
 
 from UserString import UserString
+import six
 # Create a controlled configuration for use by expandlibs
 config_win = {
     'AR': 'lib',
@@ -120,8 +121,7 @@ class ReplicateTests(type):
             del dict[name]
         return type.__new__(cls, clsName, bases, dict)
 
-class TestCaseWithTmpDir(unittest.TestCase):
-    __metaclass__ = ReplicateTests
+class TestCaseWithTmpDir(six.with_metaclass(ReplicateTests, unittest.TestCase)):
     def init(self):
         self.tmpdir = os.path.abspath(mkdtemp(dir=os.curdir))
 
diff --git a/config/tests/unit-nsinstall.py b/config/tests/unit-nsinstall.py
index 2a230841a1..ea95fd2180 100644
--- a/config/tests/unit-nsinstall.py
+++ b/config/tests/unit-nsinstall.py
@@ -28,9 +28,9 @@ class TestNsinstall(unittest.TestCase):
         # Unicode strings means non-ASCII children can be deleted properly on
         # Windows
         if sys.stdin.encoding is None:
-            tmpdir = unicode(self.tmpdir)
+            tmpdir = str(self.tmpdir)
         else:
-            tmpdir = unicode(self.tmpdir, sys.stdin.encoding)
+            tmpdir = str(self.tmpdir, sys.stdin.encoding)
         rmtree(tmpdir)
 
     # utility methods for tests
diff --git a/config/tests/unitMozZipFile.py b/config/tests/unitMozZipFile.py
index f9c0419ab5..255e61dd2b 100644
--- a/config/tests/unitMozZipFile.py
+++ b/config/tests/unitMozZipFile.py
@@ -11,6 +11,7 @@ import sys
 import random
 import copy
 from string import letters
+from functools import reduce
 
 '''
 Test case infrastructure for MozZipFile.
@@ -38,7 +39,7 @@ leafs = (
   'firstdir/oneleaf',
   'seconddir/twoleaf',
   'thirddir/with/sub/threeleaf')
-_lengths = map(lambda n: n * 64, [16, 64, 80])
+_lengths = [n * 64 for n in [16, 64, 80]]
 lengths = 3
 writes = 5
 
@@ -71,7 +72,7 @@ def getid(descs):
 def getContent(length):
   'Get pseudo random content of given length.'
   rv = [None] * length
-  for i in xrange(length):
+  for i in range(length):
     rv[i] = random.choice(letters)
   return ''.join(rv)
 
@@ -136,10 +137,10 @@ class TestExtensiveStored(unittest.TestCase):
     self.failIf(badEntry, badEntry)
     zlist = zf.namelist()
     zlist.sort()
-    vlist = self.ref.keys()
+    vlist = list(self.ref.keys())
     vlist.sort()
     self.assertEqual(zlist, vlist)
-    for leaf, content in self.ref.iteritems():
+    for leaf, content in self.ref.items():
       zcontent = zf.read(leaf)
       self.assertEqual(content, zcontent)
   
@@ -158,16 +159,16 @@ class TestExtensiveStored(unittest.TestCase):
     open(self.leaf('stage', leaf), 'w').write(content)
 
 # all leafs in all lengths
-atomics = list(prod(xrange(len(leafs)), xrange(lengths)))
+atomics = list(prod(range(len(leafs)), range(lengths)))
 
 # populate TestExtensiveStore with testcases
-for w in xrange(writes):
+for w in range(writes):
   # Don't iterate over all files for the the first n passes,
   # those are redundant as long as w < lengths.
   # There are symmetries in the trailing end, too, but I don't know
   # how to reduce those out right now.
-  nonatomics = [list(prod(range(min(i,len(leafs))), xrange(lengths)))
-                for i in xrange(1, w+1)] + [atomics]
+  nonatomics = [list(prod(list(range(min(i,len(leafs)))), range(lengths)))
+                for i in range(1, w+1)] + [atomics]
   for descs in prod(*nonatomics):
     suffix = getid(descs)
     dicts = [dict(leaf=leaf, length=length) for leaf, length in descs]
@@ -181,9 +182,9 @@ for w in xrange(writes):
 # and then write all atomics again.
 # This should catch more or less all artifacts generated
 # by the final ordering step when closing the jar.
-files = [list(prod([i], xrange(lengths))) for i in xrange(len(leafs))]
+files = [list(prod([i], range(lengths))) for i in range(len(leafs))]
 allfiles = reduce(lambda l,r:l+r,
-                  [list(prod(*files[:(i+1)])) for i in xrange(len(leafs))])
+                  [list(prod(*files[:(i+1)])) for i in range(len(leafs))])
 
 for first in allfiles:
   testbasename = 'test{0}_'.format(getid(first))
diff --git a/configure.py b/configure.py
index f7392d0ffa..abf9dca9dc 100644
--- a/configure.py
+++ b/configure.py
@@ -45,11 +45,11 @@ def config_status(config):
 
     sanitized_config = {}
     sanitized_config['substs'] = {
-        k: sanitized_bools(v) for k, v in config.iteritems()
+        k: sanitized_bools(v) for k, v in config.items()
         if k not in ('DEFINES', 'non_global_defines', 'TOPSRCDIR', 'TOPOBJDIR')
     }
     sanitized_config['defines'] = {
-        k: sanitized_bools(v) for k, v in config['DEFINES'].iteritems()
+        k: sanitized_bools(v) for k, v in config['DEFINES'].items()
     }
     sanitized_config['non_global_defines'] = config['non_global_defines']
     sanitized_config['topsrcdir'] = config['TOPSRCDIR']
@@ -71,7 +71,7 @@ def config_status(config):
         ''') % {'python': config['PYTHON'], 'encoding': encoding})
         # A lot of the build backend code is currently expecting byte
         # strings and breaks in subtle ways with unicode strings. (bug 1296508)
-        for k, v in sanitized_config.iteritems():
+        for k, v in sanitized_config.items():
             fh.write('%s = encode(%s, encoding)\n' % (k, indented_repr(v)))
         fh.write("__all__ = ['topobjdir', 'topsrcdir', 'defines', "
                  "'non_global_defines', 'substs', 'mozconfig']")
@@ -88,7 +88,7 @@ def config_status(config):
     # executable permissions.
     os.chmod('config.status', 0o755)
     if config.get('MOZ_BUILD_APP') != 'js' or config.get('JS_STANDALONE'):
-        os.environ[b'WRITE_MOZINFO'] = b'1'
+        os.environ['WRITE_MOZINFO'] = '1'
         from mozbuild.config_status import config_status
 
         # Some values in sanitized_config also have more complex types, such as
@@ -99,7 +99,7 @@ def config_status(config):
 
         # A lot of the build backend code is currently expecting byte strings
         # and breaks in subtle ways with unicode strings.
-        return config_status(args=[], **encode(sanitized_config, encoding))
+        return config_status(args=[], **sanitized_config)
     return 0
 
 
diff --git a/dom/base/test/websocket_hybi/file_binary-frames_wsh.py b/dom/base/test/websocket_hybi/file_binary-frames_wsh.py
index 656d0e1890..2f9f379726 100644
--- a/dom/base/test/websocket_hybi/file_binary-frames_wsh.py
+++ b/dom/base/test/websocket_hybi/file_binary-frames_wsh.py
@@ -15,4 +15,4 @@ def web_socket_transfer_data(request):
 
 
 def all_distinct_bytes():
-    return ''.join([chr(i) for i in xrange(256)])
+    return ''.join([chr(i) for i in range(256)])
diff --git a/dom/base/test/websocket_hybi/file_check-binary-messages_wsh.py b/dom/base/test/websocket_hybi/file_check-binary-messages_wsh.py
index 024e3f4d07..c63ca45f3a 100644
--- a/dom/base/test/websocket_hybi/file_check-binary-messages_wsh.py
+++ b/dom/base/test/websocket_hybi/file_check-binary-messages_wsh.py
@@ -18,4 +18,4 @@ def web_socket_transfer_data(request):
 
 
 def all_distinct_bytes():
-    return ''.join([chr(i) for i in xrange(256)])
+    return ''.join([chr(i) for i in range(256)])
